/**
 * vue-markdown-wasm
 *
 * @description markdown-wasm for vue 2 & 3
 * @author Logue <logue@hotmail.co.jp>
 * @copyright 2022-2023 By Masashi Yoshikawa All rights reserved.
 * @license MIT
 * @version 0.4.0
 * @see {@link https://github.com/logue/vue-markdown-wasm}
 */

import { isVue2 as i, h as d, defineComponent as c, ref as u, watch as m, nextTick as f, onMounted as p } from "vue-demi";
import { ParseFlags as w, ready as g, parse as h } from "@logue/markdown-wasm";
const V = (e) => e ? Object.entries(e).reduce((r, [t, o]) => (t = t.charAt(0).toUpperCase() + t.slice(1), t = `on${t}`, { ...r, [t]: o }), {}) : {};
function y(e, r = {}, t) {
  if (i)
    return d(e, r, t);
  const { props: o, domProps: n, on: a, ...s } = r, l = a != null ? V(a) : {};
  return d(
    e,
    { ...s, ...o, ...n, ...l },
    t
  );
}
var F = c({
  /** Component Name */
  name: "VueMarkdown",
  /** Model Definition */
  model: {
    prop: "modelValue"
  },
  /** Props Definition */
  props: {
    /** Model value */
    modelValue: {
      type: String,
      default: ""
    },
    /**
     * Using tag
     */
    tag: {
      type: String,
      default: "article"
    },
    /** Customize parsing */
    parseFlags: {
      type: Number,
      default: w.DEFAULT
    },
    /** Select output format. */
    format: {
      type: String,
      default: "xhtml"
    },
    /**
     * bytes=true causes parse() to return the result as a Uint8Array instead of a string.
     *
     * The returned Uint8Array is only valid until the next call to parse().
     * If you need to keep the returned data around, call Uint8Array.slice() to make a copy,
     * as each call to parse() uses the same underlying memory.
     *
     * This only provides a performance benefit when you never need to convert the output
     * to a string. In most cases you're better off leaving this unset or false.
     */
    bytes: {
      type: Boolean,
      default: !1
    },
    /** Allow "javascript:" in links */
    allowJsUri: {
      type: Boolean,
      default: !1
    },
    /**
     * Optional callback which if provided is called for each code block.
     * langname holds the "language tag", if any, of the block.
     *
     * The returned value is inserted into the resulting HTML verbatim, without HTML escaping.
     * Thus, you should take care of properly escaping any special HTML characters.
     *
     * If the function returns null or undefined, or an exception occurs, the body will be
     * included as-is after going through HTML escaping.
     *
     * Note that use of this callback has an adverse impact on performance as it casues
     * calls and data to be bridged between WASM and JS on every invocation.
     */
    onCodeBlock: {
      type: Function,
      default: () => {
      }
    }
  },
  /** Emits */
  emits: {
    render: (e) => !0
  },
  /**
   * Setup
   *
   * @param props  - Props
   * @param context - Context
   */
  setup(e, r) {
    const t = u(), o = u("");
    m(
      () => e,
      async (a) => {
        o.value = n(a.modelValue, {
          parseFlags: a.parseFlags,
          format: a.format,
          bytes: e.bytes,
          allowJSURIs: a.allowJsUri,
          onCodeBlock: a.onCodeBlock
        }), await f();
      },
      { deep: !0 }
    ), p(async () => {
      await g(), o.value = n(e.modelValue, {
        parseFlags: e.parseFlags,
        format: e.format,
        bytes: e.bytes,
        allowJSURIs: e.allowJsUri,
        onCodeBlock: e.onCodeBlock
      });
    });
    const n = (a, s) => {
      const l = h(a, s);
      return r.emit("render", l), l;
    };
    return r.expose({
      render: n
    }), {
      placeholder: t,
      html: o
    };
  },
  render() {
    return y(this.$props.tag, {
      ref: "placeholder",
      class: "vue-markdown",
      domProps: {
        innerHTML: this.html
      }
    });
  }
});
const C = {
  version: "0.4.0",
  date: "2024-01-08T15:48:22.611Z"
}, M = (e) => e.component("VueMarkdown", F);
export {
  C as Meta,
  F as default,
  M as install
};
